/****************************************************************************
 * This file is part of the program kullerlein                              *
 *                                                                          *
 *    Copyright (C) 2001  Roland Fleissner                                  *
 *    e-mail: fleissne@eva.mpg.de                             		    * 
 *                                                                          *
 *  This program is free software; you can redistribute it and/or modify    *
 *  it under the terms of the GNU General Public License as published by    *
 *  the Free Software Foundation; either version 2 of the License, or       *
 *  (at your option) any later version.                                     *
 *                                                                          *
 *  This program is distributed in the hope that it will be useful,         *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *  GNU General Public License for more details.                            *
 *                                                                          *
 *  You should have received a copy of the GNU General Public License       *
 *  along with this program; if not, write to the                           *
 *  Free Software Foundation, Inc., 59 Temple Place, Suite 330,             *
 *  Boston, MA  02111-1307  USA                                             *
 ****************************************************************************/

#ifndef DATA_H
#define DATA_H

#define FALSE 0
#define TRUE 1

class dataset {
public:
    vector <vector <char> > Identif;
    vector <vector <char> > Seqs;
    alphsize typ;

    dataset();
    dataset(ifstream& datei,int seqform);
    dataset(baum *b, alphsize alf);
    ~dataset();
    void fromfasta(ifstream& datei);
    void fromphylip(ifstream& datei);
    void print_phylip(ostream& ostr);
    void print_screen(ostream& ostr);
    void print_fasta(ostream& ostr);
    unsigned int spez() const; // gibt Anzahl der Sequ. zurueck
    int laen(int s) const; // gibt Laenge der Sequenz s (angefangen bei 0) zurueck
    void guesstype(); // ermittelt Sequenztyp
    void getfreqs(vector<double>& f); // ermittelt absolute Zustandshaeufigkeiten
    void getAAfreqs(vector<double>& f); // ermittelt absolute Aminosaeurehaeufigkeiten
    void getACGT(vector<double>& f); // ermittelt absolute Basenhaeufigkeiten
    void row(unsigned int i, vector<char>& rowvec);  // schreibt Spalte i nach rowvec
    void push_mult(baum *b, vector<int>& ali_to_node, vector<int>& node_to_ali,
                  vector<vector<char> >& idmat, vector<vector<char> >& seqmat);
    bool validcolumn(vector<char>& col, unsigned int expsize);
    bool notatend(vector<zustand>& pzus, bool& syncstart);
};

ostream& operator<<(ostream& ostr, const vector<char>& d);
//ostream& operator<<(ostream& ostr, const dna_with_gaps& d);

/*
class profil : public vector<vector<double> > {
public :
   profil();
   profil(vector<char>& seq, int typ);
  ~profil();
   int laen() const;
   void print_profil();
};*/

zustand get_zust(vector<int>& pAB, vector<int>& pBA, int a, int b);
zustand iter_zust(vector<int>& AvsB, vector<int>& BvsA, vector<int>& indices);

#endif
