/****************************************************************************
 * This file is part of the program alifritz                                *
 *                                                                          *
 *    Copyright (C) 2001  Roland Fleissner                                  *
 *    e-mail: fleissne@eva.mpg.de                             		    * 
 *                                                                          *
 *  This program is free software; you can redistribute it and/or modify    *
 *  it under the terms of the GNU General Public License as published by    *
 *  the Free Software Foundation; either version 2 of the License, or       *
 *  (at your option) any later version.                                     *
 *                                                                          *
 *  This program is distributed in the hope that it will be useful,         *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *  GNU General Public License for more details.                            *
 *                                                                          *
 *  You should have received a copy of the GNU General Public License       *
 *  along with this program; if not, write to the                           *
 *  Free Software Foundation, Inc., 59 Temple Place, Suite 330,             *
 *  Boston, MA  02111-1307  USA                                             *
 ****************************************************************************/

#ifndef EINGABE_H
#define EINGABE_H

#define FALSE 0
#define TRUE 1

class substmod_parameters {
public :
   subarch model;
   vector<double> params;
   vector<double> freqs;
   bool freqset;
   
   // nur fuer adjust von Bedeutung
   bool modelset;
   bool paramset;
   
   substmod_parameters();
   void adjust(subst_option so,string argument,option_arg oa);
   void setmodel(string argument,option_arg oa);
   void setparams(string argument,option_arg oa);
   void setfreqs(string argument,option_arg oa);
   void abgleich();
   alphsize retalf();
   vector<double>& retfreqs();
};


class indel_parameters {
public :
   idarch model;
   vector<double> params;
   
   // nur fuer adjust von Bedeutung
   bool modelset;
   bool paramset;

   indel_parameters();
   void adjust(indel_option so,string argument,option_arg oa);
   void setmodel(string argument,option_arg oa);
   void setparams(string argument,option_arg oa);
   void abgleich();
};


class filenames {
public :
   string treefile, alifile, seqfile;
   filenames();
   void adjust(files_option fo, string name);
};

class eingabe_parameter {
public :
    substmod_parameters sub;
    indel_parameters ind;
    filenames fil;

    eingabe_parameter();
    void from_file(char * dateiname)
        /* Eingabe der eingabe_parameter aus Datei dateiname 
	 */;
};

#endif
