/****************************************************************************
 * This file is part of the program alifritz                                *
 *                                                                          *
 *    Copyright (C) 2001  Roland Fleissner                                  *
 *    e-mail: fleissne@eva.mpg.de                             		    * 
 *                                                                          *
 *  This program is free software; you can redistribute it and/or modify    *
 *  it under the terms of the GNU General Public License as published by    *
 *  the Free Software Foundation; either version 2 of the License, or       *
 *  (at your option) any later version.                                     *
 *                                                                          *
 *  This program is distributed in the hope that it will be useful,         *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *  GNU General Public License for more details.                            *
 *                                                                          *
 *  You should have received a copy of the GNU General Public License       *
 *  along with this program; if not, write to the                           *
 *  Free Software Foundation, Inc., 59 Temple Place, Suite 330,             *
 *  Boston, MA  02111-1307  USA                                             *
 ****************************************************************************/

#ifndef PARSER_H
#define PARSER_H

#define FALSE 0
#define TRUE 1

// enumerations for the parser of the input script
enum scriptpart {scNONE=0,SUBST=1,INDEL=2,FILES=3,KEEP=4,COOL=5};
enum subst_option {suNONE=0,SMODEL=1,SPARAM=2,FREQS=3};
enum indel_option {inNONE=0,IMODEL=1,IPARAM=2};
enum files_option {fiNONE=0,TREEFILE=1,ALIFILE=2,SEQFILE=3};
enum option_arg {opNONE=0,DEFAULT=1,ESTIMATE=2,VALUE=3,VECTOR=4,INTERVAL=5,ALL=6};

scriptpart isnewpart(string Zeile);

subst_option whichsubstoption(string Zeile, string& arg, option_arg& argtype);
bool issubstmodel(string arg);
bool issubstparameter(string arg);
bool issubstfreqs(string arg);

indel_option whichindeloption(string Zeile, string& arg, option_arg& argtype);
bool isindmodel(string arg);
bool isindparameter(string arg);

files_option whichfilesoption(string Zeile, string& arg, option_arg& argtype);
bool istreefile(string arg);
bool isalifile(string arg);
bool isseqfile(string arg);

option_arg typ_of_arg(string& arg);
void stringtovector(string s, vector<double>& v);
void stringtovector(string s, vector<unsigned long int>& v);
void stringtolist(string s, list<int>& v);

string oatostring(option_arg oa);
string firstword(string arg);

#endif
