/****************************************************************************
 * This file is part of the program kullerlein                              *
 *                                                                          *
 *    Copyright (C) 2001  Roland Fleissner                                  *
 *    e-mail: fleissne@eva.mpg.de                             		    * 
 *                                                                          *
 *  This program is free software; you can redistribute it and/or modify    *
 *  it under the terms of the GNU General Public License as published by    *
 *  the Free Software Foundation; either version 2 of the License, or       *
 *  (at your option) any later version.                                     *
 *                                                                          *
 *  This program is distributed in the hope that it will be useful,         *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *  GNU General Public License for more details.                            *
 *                                                                          *
 *  You should have received a copy of the GNU General Public License       *
 *  along with this program; if not, write to the                           *
 *  Free Software Foundation, Inc., 59 Temple Place, Suite 330,             *
 *  Boston, MA  02111-1307  USA                                             *
 ****************************************************************************/

#ifndef SEQCODE_H
#define SEQCODE_H

#define FALSE 0
#define TRUE 1

enum idarch {TKF1 = 0, TKF2 = 1, FID = 2};
enum subarch {GENREV=0,TAMNEI=1,HKY=2,KIMURA2P=3,KIMURA3P=4,FEL81=5,JC69=6,
              MV2000=7,JTT=8,DAYHOFF=9,MTREV24=10,BLOSUM62=11,
	      SH94=12};

enum Base {dAtp=0,dCtp=1,dGtp=2,dTtp=3,dRtp=4,dYtp=5,
           dMtp=6,dWtp=7,dStp=8,dKtp=9,dBtp=10,dDtp=11,
	   dHtp=12,dVtp=13,dNtp=14};
enum AminoAcid {ALA=0,CYS=1,ASP=2,GLU=3,PHE=4,
                GLY=5,HIS=6,ILE=7,LYS=8,LEU=9,
		MET=10,ASN=11,PRO=12,GLN=13,ARG=14,
		SER=15,THR=16,VAL=17,TRP=18,TYR=19,
		ASX=20,GLX=21,XXX=22};//auf keinen Fall Numerierung veraendern!
enum alphsize {DNA=4,PROTEIN=20,DOUBLET=16};
	      
int whichbase(char c, int alf);
void whichbase(vector<bool>& basbas, char c);
char state_to_char(int i,alphsize typ);
char basetochar(int i);
Base chartobase(char c);
void chartobase(char c, vector<int>& bases);
char amactochar(int i);
AminoAcid chartoamac(char c);
void chartoamac(char c, vector<int>& amacs);
int alftologalf(int alf); // Wieviele Zustaende (auch unsichere) gibt's?
void whichwildcard(int wc,vector<bool>& zus);
void whichwc(char wc,vector<int>& zus, int alf);
//char profile_to_char(vector<double>& prof);
//char basprof_tochar(vector<double>& prof);
//char amacprof_tochar(vector<double>& prof);

subarch stringtosubarch(string arg);
idarch stringtoidarch(string arg);
bool findanycase(string text, string pattern);


#endif
